# swagger-client
Figshare apiv2. Using Swagger 2.0

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth2
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ArticlesApi(swagger_client.ApiClient(configuration))
group_id = 789 # int | A group ID to filter by (optional)

try:
    # Account Article Report
    api_response = api_instance.account_article_report(group_id=group_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ArticlesApi->account_article_report: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.figshare.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ArticlesApi* | [**account_article_report**](docs/ArticlesApi.md#account_article_report) | **GET** /account/articles/export | Account Article Report
*ArticlesApi* | [**account_article_report_generate**](docs/ArticlesApi.md#account_article_report_generate) | **POST** /account/articles/export | Initiate a new Report
*ArticlesApi* | [**article_details**](docs/ArticlesApi.md#article_details) | **GET** /articles/{article_id} | View article details
*ArticlesApi* | [**article_file_details**](docs/ArticlesApi.md#article_file_details) | **GET** /articles/{article_id}/files/{file_id} | Article file details
*ArticlesApi* | [**article_files**](docs/ArticlesApi.md#article_files) | **GET** /articles/{article_id}/files | List article files
*ArticlesApi* | [**article_version_confidentiality**](docs/ArticlesApi.md#article_version_confidentiality) | **GET** /articles/{article_id}/versions/{v_number}/confidentiality | Public Article Confidentiality for article version
*ArticlesApi* | [**article_version_details**](docs/ArticlesApi.md#article_version_details) | **GET** /articles/{article_id}/versions/{v_number} | Article details for version
*ArticlesApi* | [**article_version_embargo**](docs/ArticlesApi.md#article_version_embargo) | **GET** /articles/{article_id}/versions/{v_number}/embargo | Public Article Embargo for article version
*ArticlesApi* | [**article_version_update**](docs/ArticlesApi.md#article_version_update) | **PUT** /account/articles/{article_id}/versions/{version_id}/ | Update article version
*ArticlesApi* | [**article_version_update_thumb**](docs/ArticlesApi.md#article_version_update_thumb) | **PUT** /account/articles/{article_id}/versions/{version_id}/update_thumb | Update article version thumbnail
*ArticlesApi* | [**article_versions**](docs/ArticlesApi.md#article_versions) | **GET** /articles/{article_id}/versions | List article versions
*ArticlesApi* | [**articles_list**](docs/ArticlesApi.md#articles_list) | **GET** /articles | Public Articles
*ArticlesApi* | [**articles_search**](docs/ArticlesApi.md#articles_search) | **POST** /articles/search | Public Articles Search
*ArticlesApi* | [**private_article_author_delete**](docs/ArticlesApi.md#private_article_author_delete) | **DELETE** /account/articles/{article_id}/authors/{author_id} | Delete article author
*ArticlesApi* | [**private_article_authors_add**](docs/ArticlesApi.md#private_article_authors_add) | **POST** /account/articles/{article_id}/authors | Add article authors
*ArticlesApi* | [**private_article_authors_list**](docs/ArticlesApi.md#private_article_authors_list) | **GET** /account/articles/{article_id}/authors | List article authors
*ArticlesApi* | [**private_article_authors_replace**](docs/ArticlesApi.md#private_article_authors_replace) | **PUT** /account/articles/{article_id}/authors | Replace article authors
*ArticlesApi* | [**private_article_categories_add**](docs/ArticlesApi.md#private_article_categories_add) | **POST** /account/articles/{article_id}/categories | Add article categories
*ArticlesApi* | [**private_article_categories_list**](docs/ArticlesApi.md#private_article_categories_list) | **GET** /account/articles/{article_id}/categories | List article categories
*ArticlesApi* | [**private_article_categories_replace**](docs/ArticlesApi.md#private_article_categories_replace) | **PUT** /account/articles/{article_id}/categories | Replace article categories
*ArticlesApi* | [**private_article_category_delete**](docs/ArticlesApi.md#private_article_category_delete) | **DELETE** /account/articles/{article_id}/categories/{category_id} | Delete article category
*ArticlesApi* | [**private_article_confidentiality_delete**](docs/ArticlesApi.md#private_article_confidentiality_delete) | **DELETE** /account/articles/{article_id}/confidentiality | Delete article confidentiality
*ArticlesApi* | [**private_article_confidentiality_details**](docs/ArticlesApi.md#private_article_confidentiality_details) | **GET** /account/articles/{article_id}/confidentiality | Article confidentiality details
*ArticlesApi* | [**private_article_confidentiality_update**](docs/ArticlesApi.md#private_article_confidentiality_update) | **PUT** /account/articles/{article_id}/confidentiality | Update article confidentiality
*ArticlesApi* | [**private_article_create**](docs/ArticlesApi.md#private_article_create) | **POST** /account/articles | Create new Article
*ArticlesApi* | [**private_article_delete**](docs/ArticlesApi.md#private_article_delete) | **DELETE** /account/articles/{article_id} | Delete article
*ArticlesApi* | [**private_article_details**](docs/ArticlesApi.md#private_article_details) | **GET** /account/articles/{article_id} | Article details
*ArticlesApi* | [**private_article_embargo_delete**](docs/ArticlesApi.md#private_article_embargo_delete) | **DELETE** /account/articles/{article_id}/embargo | Delete Article Embargo
*ArticlesApi* | [**private_article_embargo_details**](docs/ArticlesApi.md#private_article_embargo_details) | **GET** /account/articles/{article_id}/embargo | Article Embargo Details
*ArticlesApi* | [**private_article_embargo_update**](docs/ArticlesApi.md#private_article_embargo_update) | **PUT** /account/articles/{article_id}/embargo | Update Article Embargo
*ArticlesApi* | [**private_article_file**](docs/ArticlesApi.md#private_article_file) | **GET** /account/articles/{article_id}/files/{file_id} | Single File
*ArticlesApi* | [**private_article_file_delete**](docs/ArticlesApi.md#private_article_file_delete) | **DELETE** /account/articles/{article_id}/files/{file_id} | File Delete
*ArticlesApi* | [**private_article_files_list**](docs/ArticlesApi.md#private_article_files_list) | **GET** /account/articles/{article_id}/files | List article files
*ArticlesApi* | [**private_article_private_link**](docs/ArticlesApi.md#private_article_private_link) | **GET** /account/articles/{article_id}/private_links | List private links
*ArticlesApi* | [**private_article_private_link_create**](docs/ArticlesApi.md#private_article_private_link_create) | **POST** /account/articles/{article_id}/private_links | Create private link
*ArticlesApi* | [**private_article_private_link_delete**](docs/ArticlesApi.md#private_article_private_link_delete) | **DELETE** /account/articles/{article_id}/private_links/{link_id} | Disable private link
*ArticlesApi* | [**private_article_private_link_update**](docs/ArticlesApi.md#private_article_private_link_update) | **PUT** /account/articles/{article_id}/private_links/{link_id} | Update private link
*ArticlesApi* | [**private_article_publish**](docs/ArticlesApi.md#private_article_publish) | **POST** /account/articles/{article_id}/publish | Private Article Publish
*ArticlesApi* | [**private_article_reserve_doi**](docs/ArticlesApi.md#private_article_reserve_doi) | **POST** /account/articles/{article_id}/reserve_doi | Private Article Reserve DOI
*ArticlesApi* | [**private_article_reserve_handle**](docs/ArticlesApi.md#private_article_reserve_handle) | **POST** /account/articles/{article_id}/reserve_handle | Private Article Reserve Handle
*ArticlesApi* | [**private_article_resource**](docs/ArticlesApi.md#private_article_resource) | **POST** /account/articles/{article_id}/resource | Private Article Resource
*ArticlesApi* | [**private_article_update**](docs/ArticlesApi.md#private_article_update) | **PUT** /account/articles/{article_id} | Update article
*ArticlesApi* | [**private_article_upload_complete**](docs/ArticlesApi.md#private_article_upload_complete) | **POST** /account/articles/{article_id}/files/{file_id} | Complete Upload
*ArticlesApi* | [**private_article_upload_initiate**](docs/ArticlesApi.md#private_article_upload_initiate) | **POST** /account/articles/{article_id}/files | Initiate Upload
*ArticlesApi* | [**private_articles_list**](docs/ArticlesApi.md#private_articles_list) | **GET** /account/articles | Private Articles
*ArticlesApi* | [**private_articles_search**](docs/ArticlesApi.md#private_articles_search) | **POST** /account/articles/search | Private Articles search
*AuthorsApi* | [**private_author_details**](docs/AuthorsApi.md#private_author_details) | **GET** /account/authors/{author_id} | Author details
*AuthorsApi* | [**private_authors_search**](docs/AuthorsApi.md#private_authors_search) | **POST** /account/authors/search | Search Authors
*CollectionsApi* | [**collection_articles**](docs/CollectionsApi.md#collection_articles) | **GET** /collections/{collection_id}/articles | Public Collection Articles
*CollectionsApi* | [**collection_details**](docs/CollectionsApi.md#collection_details) | **GET** /collections/{collection_id} | Collection details
*CollectionsApi* | [**collection_version_details**](docs/CollectionsApi.md#collection_version_details) | **GET** /collections/{collection_id}/versions/{version_id} | Collection Version details
*CollectionsApi* | [**collection_versions**](docs/CollectionsApi.md#collection_versions) | **GET** /collections/{collection_id}/versions | Collection Versions list
*CollectionsApi* | [**collections_list**](docs/CollectionsApi.md#collections_list) | **GET** /collections | Public Collections
*CollectionsApi* | [**collections_search**](docs/CollectionsApi.md#collections_search) | **POST** /collections/search | Public Collections Search
*CollectionsApi* | [**private_collection_article_delete**](docs/CollectionsApi.md#private_collection_article_delete) | **DELETE** /account/collections/{collection_id}/articles/{article_id} | Delete collection article
*CollectionsApi* | [**private_collection_articles_add**](docs/CollectionsApi.md#private_collection_articles_add) | **POST** /account/collections/{collection_id}/articles | Add collection articles
*CollectionsApi* | [**private_collection_articles_list**](docs/CollectionsApi.md#private_collection_articles_list) | **GET** /account/collections/{collection_id}/articles | List collection articles
*CollectionsApi* | [**private_collection_articles_replace**](docs/CollectionsApi.md#private_collection_articles_replace) | **PUT** /account/collections/{collection_id}/articles | Replace collection articles
*CollectionsApi* | [**private_collection_author_delete**](docs/CollectionsApi.md#private_collection_author_delete) | **DELETE** /account/collections/{collection_id}/authors/{author_id} | Delete collection author
*CollectionsApi* | [**private_collection_authors_add**](docs/CollectionsApi.md#private_collection_authors_add) | **POST** /account/collections/{collection_id}/authors | Add collection authors
*CollectionsApi* | [**private_collection_authors_list**](docs/CollectionsApi.md#private_collection_authors_list) | **GET** /account/collections/{collection_id}/authors | List collection authors
*CollectionsApi* | [**private_collection_authors_replace**](docs/CollectionsApi.md#private_collection_authors_replace) | **PUT** /account/collections/{collection_id}/authors | Replace collection authors
*CollectionsApi* | [**private_collection_categories_add**](docs/CollectionsApi.md#private_collection_categories_add) | **POST** /account/collections/{collection_id}/categories | Add collection categories
*CollectionsApi* | [**private_collection_categories_list**](docs/CollectionsApi.md#private_collection_categories_list) | **GET** /account/collections/{collection_id}/categories | List collection categories
*CollectionsApi* | [**private_collection_categories_replace**](docs/CollectionsApi.md#private_collection_categories_replace) | **PUT** /account/collections/{collection_id}/categories | Replace collection categories
*CollectionsApi* | [**private_collection_category_delete**](docs/CollectionsApi.md#private_collection_category_delete) | **DELETE** /account/collections/{collection_id}/categories/{category_id} | Delete collection category
*CollectionsApi* | [**private_collection_create**](docs/CollectionsApi.md#private_collection_create) | **POST** /account/collections | Create collection
*CollectionsApi* | [**private_collection_delete**](docs/CollectionsApi.md#private_collection_delete) | **DELETE** /account/collections/{collection_id} | Delete collection
*CollectionsApi* | [**private_collection_details**](docs/CollectionsApi.md#private_collection_details) | **GET** /account/collections/{collection_id} | Collection details
*CollectionsApi* | [**private_collection_private_link_create**](docs/CollectionsApi.md#private_collection_private_link_create) | **POST** /account/collections/{collection_id}/private_links | Create collection private link
*CollectionsApi* | [**private_collection_private_link_delete**](docs/CollectionsApi.md#private_collection_private_link_delete) | **DELETE** /account/collections/{collection_id}/private_links/{link_id} | Disable private link
*CollectionsApi* | [**private_collection_private_link_update**](docs/CollectionsApi.md#private_collection_private_link_update) | **PUT** /account/collections/{collection_id}/private_links/{link_id} | Update collection private link
*CollectionsApi* | [**private_collection_private_links_list**](docs/CollectionsApi.md#private_collection_private_links_list) | **GET** /account/collections/{collection_id}/private_links | List collection private links
*CollectionsApi* | [**private_collection_publish**](docs/CollectionsApi.md#private_collection_publish) | **POST** /account/collections/{collection_id}/publish | Private Collection Publish
*CollectionsApi* | [**private_collection_reserve_doi**](docs/CollectionsApi.md#private_collection_reserve_doi) | **POST** /account/collections/{collection_id}/reserve_doi | Private Collection Reserve DOI
*CollectionsApi* | [**private_collection_reserve_handle**](docs/CollectionsApi.md#private_collection_reserve_handle) | **POST** /account/collections/{collection_id}/reserve_handle | Private Collection Reserve Handle
*CollectionsApi* | [**private_collection_resource**](docs/CollectionsApi.md#private_collection_resource) | **POST** /account/collections/{collection_id}/resource | Private Collection Resource
*CollectionsApi* | [**private_collection_update**](docs/CollectionsApi.md#private_collection_update) | **PUT** /account/collections/{collection_id} | Update collection
*CollectionsApi* | [**private_collections_list**](docs/CollectionsApi.md#private_collections_list) | **GET** /account/collections | Private Collections List
*CollectionsApi* | [**private_collections_search**](docs/CollectionsApi.md#private_collections_search) | **POST** /account/collections/search | Private Collections Search
*InstitutionsApi* | [**account_institution_curation**](docs/InstitutionsApi.md#account_institution_curation) | **GET** /account/institution/review/{curation_id} | Institution Curation Review
*InstitutionsApi* | [**account_institution_curation_comments**](docs/InstitutionsApi.md#account_institution_curation_comments) | **GET** /account/institution/review/{curation_id}/comments | Institution Curation Review Comments
*InstitutionsApi* | [**account_institution_curation_comments_0**](docs/InstitutionsApi.md#account_institution_curation_comments_0) | **POST** /account/institution/review/{curation_id}/comments | POST Institution Curation Review Comment
*InstitutionsApi* | [**account_institution_curations**](docs/InstitutionsApi.md#account_institution_curations) | **GET** /account/institution/reviews | Institution Curation Reviews
*InstitutionsApi* | [**custom_fields_list**](docs/InstitutionsApi.md#custom_fields_list) | **GET** /account/institution/custom_fields | Private account institution group custom fields
*InstitutionsApi* | [**custom_fields_upload**](docs/InstitutionsApi.md#custom_fields_upload) | **POST** /account/institution/custom_fields/{custom_field_id}/items/upload | Custom fields values files upload
*InstitutionsApi* | [**institution_articles**](docs/InstitutionsApi.md#institution_articles) | **GET** /institutions/{institution_string_id}/articles/filter-by | Public Institution Articles
*InstitutionsApi* | [**institution_hrfeed_upload**](docs/InstitutionsApi.md#institution_hrfeed_upload) | **POST** /institution/hrfeed/upload | Private Institution HRfeed Upload
*InstitutionsApi* | [**private_account_institution_user**](docs/InstitutionsApi.md#private_account_institution_user) | **GET** /account/institution/users/{account_id} | Private Account Institution User
*InstitutionsApi* | [**private_categories_list**](docs/InstitutionsApi.md#private_categories_list) | **GET** /account/categories | Private Account Categories
*InstitutionsApi* | [**private_group_embargo_options_details**](docs/InstitutionsApi.md#private_group_embargo_options_details) | **GET** /account/institution/groups/{group_id}/embargo_options | Private Account Institution Group Embargo Options
*InstitutionsApi* | [**private_institution_account_group_role_delete**](docs/InstitutionsApi.md#private_institution_account_group_role_delete) | **DELETE** /account/institution/roles/{account_id}/{group_id}/{role_id} | Delete Institution Account Group Role
*InstitutionsApi* | [**private_institution_account_group_roles**](docs/InstitutionsApi.md#private_institution_account_group_roles) | **GET** /account/institution/roles/{account_id} | List Institution Account Group Roles
*InstitutionsApi* | [**private_institution_account_group_roles_create**](docs/InstitutionsApi.md#private_institution_account_group_roles_create) | **POST** /account/institution/roles/{account_id} | Add Institution Account Group Roles
*InstitutionsApi* | [**private_institution_accounts_create**](docs/InstitutionsApi.md#private_institution_accounts_create) | **POST** /account/institution/accounts | Create new Institution Account
*InstitutionsApi* | [**private_institution_accounts_list**](docs/InstitutionsApi.md#private_institution_accounts_list) | **GET** /account/institution/accounts | Private Account Institution Accounts
*InstitutionsApi* | [**private_institution_accounts_search**](docs/InstitutionsApi.md#private_institution_accounts_search) | **POST** /account/institution/accounts/search | Private Account Institution Accounts Search
*InstitutionsApi* | [**private_institution_accounts_update**](docs/InstitutionsApi.md#private_institution_accounts_update) | **PUT** /account/institution/accounts/{account_id} | Update Institution Account
*InstitutionsApi* | [**private_institution_articles**](docs/InstitutionsApi.md#private_institution_articles) | **GET** /account/institution/articles | Private Institution Articles
*InstitutionsApi* | [**private_institution_details**](docs/InstitutionsApi.md#private_institution_details) | **GET** /account/institution | Private Account Institutions
*InstitutionsApi* | [**private_institution_embargo_options_details**](docs/InstitutionsApi.md#private_institution_embargo_options_details) | **GET** /account/institution/embargo_options | Private Account Institution embargo options
*InstitutionsApi* | [**private_institution_groups_list**](docs/InstitutionsApi.md#private_institution_groups_list) | **GET** /account/institution/groups | Private Account Institution Groups
*InstitutionsApi* | [**private_institution_roles_list**](docs/InstitutionsApi.md#private_institution_roles_list) | **GET** /account/institution/roles | Private Account Institution Roles
*OtherApi* | [**categories_list**](docs/OtherApi.md#categories_list) | **GET** /categories | Public Categories
*OtherApi* | [**file_download**](docs/OtherApi.md#file_download) | **GET** /file/download/{file_id} | Public File Download
*OtherApi* | [**item_types_list**](docs/OtherApi.md#item_types_list) | **GET** /item_types | Item Types
*OtherApi* | [**licenses_list**](docs/OtherApi.md#licenses_list) | **GET** /licenses | Public Licenses
*OtherApi* | [**private_account**](docs/OtherApi.md#private_account) | **GET** /account | Private Account information
*OtherApi* | [**private_funding_search**](docs/OtherApi.md#private_funding_search) | **POST** /account/funding/search | Search Funding
*OtherApi* | [**private_licenses_list**](docs/OtherApi.md#private_licenses_list) | **GET** /account/licenses | Private Account Licenses
*ProjectsApi* | [**private_project_article_delete**](docs/ProjectsApi.md#private_project_article_delete) | **DELETE** /account/projects/{project_id}/articles/{article_id} | Delete project article
*ProjectsApi* | [**private_project_article_details**](docs/ProjectsApi.md#private_project_article_details) | **GET** /account/projects/{project_id}/articles/{article_id} | Project article details
*ProjectsApi* | [**private_project_article_file**](docs/ProjectsApi.md#private_project_article_file) | **GET** /account/projects/{project_id}/articles/{article_id}/files/{file_id} | Project article file details
*ProjectsApi* | [**private_project_article_files**](docs/ProjectsApi.md#private_project_article_files) | **GET** /account/projects/{project_id}/articles/{article_id}/files | Project article list files
*ProjectsApi* | [**private_project_articles_create**](docs/ProjectsApi.md#private_project_articles_create) | **POST** /account/projects/{project_id}/articles | Create project article
*ProjectsApi* | [**private_project_articles_list**](docs/ProjectsApi.md#private_project_articles_list) | **GET** /account/projects/{project_id}/articles | List project articles
*ProjectsApi* | [**private_project_collaborator_delete**](docs/ProjectsApi.md#private_project_collaborator_delete) | **DELETE** /account/projects/{project_id}/collaborators/{user_id} | Remove project collaborator
*ProjectsApi* | [**private_project_collaborators_invite**](docs/ProjectsApi.md#private_project_collaborators_invite) | **POST** /account/projects/{project_id}/collaborators | Invite project collaborators
*ProjectsApi* | [**private_project_collaborators_list**](docs/ProjectsApi.md#private_project_collaborators_list) | **GET** /account/projects/{project_id}/collaborators | List project collaborators
*ProjectsApi* | [**private_project_create**](docs/ProjectsApi.md#private_project_create) | **POST** /account/projects | Create project
*ProjectsApi* | [**private_project_delete**](docs/ProjectsApi.md#private_project_delete) | **DELETE** /account/projects/{project_id} | Delete project
*ProjectsApi* | [**private_project_details**](docs/ProjectsApi.md#private_project_details) | **GET** /account/projects/{project_id} | View project details
*ProjectsApi* | [**private_project_leave**](docs/ProjectsApi.md#private_project_leave) | **POST** /account/projects/{project_id}/leave | Private Project Leave
*ProjectsApi* | [**private_project_note**](docs/ProjectsApi.md#private_project_note) | **GET** /account/projects/{project_id}/notes/{note_id} | Project note details
*ProjectsApi* | [**private_project_note_delete**](docs/ProjectsApi.md#private_project_note_delete) | **DELETE** /account/projects/{project_id}/notes/{note_id} | Delete project note
*ProjectsApi* | [**private_project_note_update**](docs/ProjectsApi.md#private_project_note_update) | **PUT** /account/projects/{project_id}/notes/{note_id} | Update project note
*ProjectsApi* | [**private_project_notes_create**](docs/ProjectsApi.md#private_project_notes_create) | **POST** /account/projects/{project_id}/notes | Create project note
*ProjectsApi* | [**private_project_notes_list**](docs/ProjectsApi.md#private_project_notes_list) | **GET** /account/projects/{project_id}/notes | List project notes
*ProjectsApi* | [**private_project_publish**](docs/ProjectsApi.md#private_project_publish) | **POST** /account/projects/{project_id}/publish | Private Project Publish
*ProjectsApi* | [**private_project_update**](docs/ProjectsApi.md#private_project_update) | **PUT** /account/projects/{project_id} | Update project
*ProjectsApi* | [**private_projects_list**](docs/ProjectsApi.md#private_projects_list) | **GET** /account/projects | Private Projects
*ProjectsApi* | [**private_projects_search**](docs/ProjectsApi.md#private_projects_search) | **POST** /account/projects/search | Private Projects search
*ProjectsApi* | [**project_articles**](docs/ProjectsApi.md#project_articles) | **GET** /projects/{project_id}/articles | Public Project Articles
*ProjectsApi* | [**project_details**](docs/ProjectsApi.md#project_details) | **GET** /projects/{project_id} | Public Project
*ProjectsApi* | [**projects_list**](docs/ProjectsApi.md#projects_list) | **GET** /projects | Public Projects
*ProjectsApi* | [**projects_search**](docs/ProjectsApi.md#projects_search) | **POST** /projects/search | Public Projects Search


## Documentation For Models

 - [Account](docs/Account.md)
 - [AccountCreate](docs/AccountCreate.md)
 - [AccountGroupRoles](docs/AccountGroupRoles.md)
 - [AccountGroupRolesCreate](docs/AccountGroupRolesCreate.md)
 - [AccountReport](docs/AccountReport.md)
 - [AccountUpdate](docs/AccountUpdate.md)
 - [Article](docs/Article.md)
 - [ArticleComplete](docs/ArticleComplete.md)
 - [ArticleCompletePrivate](docs/ArticleCompletePrivate.md)
 - [ArticleConfidentiality](docs/ArticleConfidentiality.md)
 - [ArticleCreate](docs/ArticleCreate.md)
 - [ArticleDOI](docs/ArticleDOI.md)
 - [ArticleEmbargo](docs/ArticleEmbargo.md)
 - [ArticleEmbargoUpdater](docs/ArticleEmbargoUpdater.md)
 - [ArticleHandle](docs/ArticleHandle.md)
 - [ArticleProjectCreate](docs/ArticleProjectCreate.md)
 - [ArticleSearch](docs/ArticleSearch.md)
 - [ArticleUpdate](docs/ArticleUpdate.md)
 - [ArticleVersions](docs/ArticleVersions.md)
 - [ArticleWithProject](docs/ArticleWithProject.md)
 - [ArticlesCreator](docs/ArticlesCreator.md)
 - [Author](docs/Author.md)
 - [AuthorComplete](docs/AuthorComplete.md)
 - [AuthorsCreator](docs/AuthorsCreator.md)
 - [CategoriesCreator](docs/CategoriesCreator.md)
 - [Category](docs/Category.md)
 - [Collaborator](docs/Collaborator.md)
 - [Collection](docs/Collection.md)
 - [CollectionComplete](docs/CollectionComplete.md)
 - [CollectionCompletePrivate](docs/CollectionCompletePrivate.md)
 - [CollectionCreate](docs/CollectionCreate.md)
 - [CollectionDOI](docs/CollectionDOI.md)
 - [CollectionHandle](docs/CollectionHandle.md)
 - [CollectionPrivateLinkCreator](docs/CollectionPrivateLinkCreator.md)
 - [CollectionSearch](docs/CollectionSearch.md)
 - [CollectionUpdate](docs/CollectionUpdate.md)
 - [CollectionVersions](docs/CollectionVersions.md)
 - [CommonSearch](docs/CommonSearch.md)
 - [ConfidentialityCreator](docs/ConfidentialityCreator.md)
 - [CreateProjectResponse](docs/CreateProjectResponse.md)
 - [Curation](docs/Curation.md)
 - [CurationComment](docs/CurationComment.md)
 - [CurationCommentCreate](docs/CurationCommentCreate.md)
 - [CurationDetail](docs/CurationDetail.md)
 - [CustomArticleField](docs/CustomArticleField.md)
 - [CustomArticleFieldAdd](docs/CustomArticleFieldAdd.md)
 - [ErrorMessage](docs/ErrorMessage.md)
 - [FileCreator](docs/FileCreator.md)
 - [FileId](docs/FileId.md)
 - [FundingCreate](docs/FundingCreate.md)
 - [FundingInformation](docs/FundingInformation.md)
 - [FundingSearch](docs/FundingSearch.md)
 - [Group](docs/Group.md)
 - [GroupEmbargoOptions](docs/GroupEmbargoOptions.md)
 - [Institution](docs/Institution.md)
 - [InstitutionAccountsSearch](docs/InstitutionAccountsSearch.md)
 - [ItemType](docs/ItemType.md)
 - [License](docs/License.md)
 - [Location](docs/Location.md)
 - [LocationWarnings](docs/LocationWarnings.md)
 - [LocationWarningsUpdate](docs/LocationWarningsUpdate.md)
 - [PrivateArticleSearch](docs/PrivateArticleSearch.md)
 - [PrivateAuthorsSearch](docs/PrivateAuthorsSearch.md)
 - [PrivateCollectionSearch](docs/PrivateCollectionSearch.md)
 - [PrivateFile](docs/PrivateFile.md)
 - [PrivateLink](docs/PrivateLink.md)
 - [PrivateLinkCreator](docs/PrivateLinkCreator.md)
 - [PrivateLinkResponse](docs/PrivateLinkResponse.md)
 - [Project](docs/Project.md)
 - [ProjectArticle](docs/ProjectArticle.md)
 - [ProjectCollaborator](docs/ProjectCollaborator.md)
 - [ProjectCollaboratorInvite](docs/ProjectCollaboratorInvite.md)
 - [ProjectComplete](docs/ProjectComplete.md)
 - [ProjectCompletePrivate](docs/ProjectCompletePrivate.md)
 - [ProjectCreate](docs/ProjectCreate.md)
 - [ProjectNote](docs/ProjectNote.md)
 - [ProjectNoteCreate](docs/ProjectNoteCreate.md)
 - [ProjectNotePrivate](docs/ProjectNotePrivate.md)
 - [ProjectPrivate](docs/ProjectPrivate.md)
 - [ProjectUpdate](docs/ProjectUpdate.md)
 - [ProjectsSearch](docs/ProjectsSearch.md)
 - [PublicFile](docs/PublicFile.md)
 - [RelatedMaterial](docs/RelatedMaterial.md)
 - [Resource](docs/Resource.md)
 - [ResponseMessage](docs/ResponseMessage.md)
 - [Role](docs/Role.md)
 - [ShortAccount](docs/ShortAccount.md)
 - [ShortCustomField](docs/ShortCustomField.md)
 - [Timeline](docs/Timeline.md)
 - [TimelineUpdate](docs/TimelineUpdate.md)
 - [UploadFilePart](docs/UploadFilePart.md)
 - [UploadInfo](docs/UploadInfo.md)
 - [User](docs/User.md)


## Documentation For Authorization


## OAuth2

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://figshare.com/account/applications/authorize
- **Scopes**: 
 - **all**: Grants all access


## Author



